Installing AWS infrastructure through Terraform scripts
==============================================================================

This file explains how to set up the expected infrastructure awaited to implement the JSON API.
The installation is based on Terraform (https://www.terraform.io/)

It expects that both AWS CLI and Terraform have been previously installed and set up correctly. 
The AWS Credentials should also have been set up 

How it works
------------------------------------------------------------------------------
AWS JSON API server relies on 3 main components, plus the needed IAM roles :
- A DynamoDB table manipuling all serialized objects
- A lambda function in charge of the translation from JSON API format to dynamoDB objects and managing the relationships and the optional parameters provided in the request
- An API Gateway configured to received the REST HTTP requests and proxying the Lambda

It also create three S3 buckets, one for storing the lambda code (nammed lambda-jsonapi-code-bucket) and the two other for receiving the ‘staging’ and ‘production’ version of the application (respectively nammed ember-aws-ehipster-staging and ember-aws-ehipster-production)

Several Terraform files are available, each one creating the needed component and their relationships with each other.

Installation
------------------------------------------------------------------------------

One this is done, simply run the terraform script :
```
terraform init
terraform apply -var bucket_name=<bucket name for static web site>
```